/*
 * ct.h		common declatations and definitions
 *
 *              This program is free software; you can redistribute it and/or
 *              modify it under the terms of the GNU General Public License
 *              as published by the Free Software Foundation; either version
 *              2 of the License, or (at your option) any later version.
 *
 * Authors:     Patrick McHardy, <kaber@trash.net>
 */

#ifndef _CT_H_
#define _CT_H

#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <asm/types.h>
#include <linux/if.h>
#include <linux/netlink.h>
#include <linux/netfilter_ipv4/ip_nat.h>
#include <linux/netfilter_ipv4/ip_tables.h>
#include <linux/netfilter_ipv4/ip_conntrack.h>
#include <linux/netfilter_ipv4/ip_conntrack_tcp.h>
#include <linux/netfilter_ipv4/ip_conntrack_ftp.h>
#include <linux/netfilter_ipv4/ip_conntrack_icmp.h>
#include <linux/netfilter_ipv4/ip_conntrack_tuple.h>
#include <linux/nfnetlink_conntrack.h>
#include <libnfnetlink.h>

#define NETLINK_SOCKBUFSZ	(1<<20)
#define CTSYNCD_DEFPORT		10000

#define MULTICAST(x)		(((x) & htonl(0xF0000000)) == htonl(0xE0000000))
#define LOCAL_MCAST(x)		(((x) & htonl(0xFFFFFF00)) == htonl(0xE0000000))


extern int ctsyncd(int, char **);
extern int ctmonitor(int, char **);
extern int ctadd(int, char **);
extern int ctchange(int, char **);
extern int ctdel(int, char **);
extern int ctlist(int, char **);

extern void incomplete_command(void);
extern int unknown_arg(char *);

#define NEXT_ARG()			\
do {					\
	argv++;				\
	if (--argc <= 0)		\
		incomplete_command();	\
} while(0)

#define _NEXT_ARG()			\
do {					\
	argv++, eaten++;		\
	if (--argc <= 0)		\
		incomplete_command();   \
} while(0)

#endif /* _CT_H */
