/*
 * utils.h      declarations of common helper functions
 *
 *              This program is free software; you can redistribute it and/or
 *              modify it under the terms of the GNU General Public License
 *              as published by the Free Software Foundation; either version
 *              2 of the License, or (at your option) any later version.
 *
 * Authors:     Patrick McHardy, <kaber@trash.net>
 */

#ifndef _UTIL_H
#define _UTIL_H

#include <netinet/in.h>
#include <libnfnetlink.h>
#include <linux/nfnetlink_conntrack.h>

#define NIPQUAD(addr) \
	((unsigned char *)&addr)[0], \
	((unsigned char *)&addr)[1], \
	((unsigned char *)&addr)[2], \
	((unsigned char *)&addr)[3]

extern int get_integer(int *, char *, int);
extern int get_unsigned(unsigned *, char *, int);
extern int get_ulong(unsigned long *, char *, int);
extern int get_u16(__u16 *, char *, int);
extern int get_u8(__u8 *, char *, int);
extern int get_addr(__u32 *, char *);
extern int get_size(unsigned int *, char *);
extern int get_tuple(struct ip_conntrack_tuple *, int, char **);
extern int get_status(unsigned long *, char *);
extern int get_protoinfo(struct cta_proto *, int, char **);
extern int get_helpinfo(struct cta_help *, int, char **);
extern int get_natinfo(struct cta_nat *, int, char **);
extern int get_nlmcgroups(__u32 *, char *);
extern unsigned int get_sock_rmem_max(void);
extern int ctnl_parse_attr(struct nfattr **, int, struct nfattr *, int);
extern int matches(char *, char *);

extern int print_nlmsg(FILE *, struct nlmsghdr *);
#endif /* _UTIL_H */
